// sapien.cpp : common implementation for all sapien link targets

#include "sapien.h"

char *cmd[NCMDSAPIEN] = { "turn_right", "right_arm_up", "right_arm_out", "tilt_body_right",
                    "right_arm_down", "right_arm_in", "walk_forward", "walk_backward",
                    "turn_left", "left_arm_up", "left_arm_out", "tilt_body_left",
                    "left_arm_down", "left_arm_in", "stop", "-", "master_program",
                    "play", "right_program", "left_program", "sonic_program",
                    "-", "-", "-", "quiet_execute", "-", "quiet_execute_with_subroutines", "-",
                    "-", "-", "-", "-",
                    "right_turn_step", "right_hand_thump", "right_hand_throw",
                    "sleep", "right_hand_pickup", "lean_backward", "forward_step",
                    "backward_step", "left_turn_step", "left_hand_thump",
                    "left_hand_throw", "listen", "left_hand_pickup", "lean_forward" ,
                    "reset", "-", "master_execute", "wakeup", "right_execute", "left_execute",
                    "sonic_execute", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
                    "right_hand_strike_3", "right_hand_sweep",
                    "burp", "right_hand_strike", "high_5", "right_hand_strike_1",
                    "bulldozer", "oops", "left_hand_strike_3", "left_hand_sweep",
                    "whistle", "left_hand_strike_2", "talkback", "left_hand_strike_1",
                    "roar", "-", "all_demo", "power_off", "demo_1", "demo_2", "dance", "-", "karate_chop",
                    "-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-",
                    "-","-","-","-","-","-","-","-","-","-","-",
                    "feet_shuffle", "-","-","-","-","nothing", "raise_arm_throw","-","-","-"  };

char *cmd2[NCMDSAPIEN2] = { "_walking",
                        "stop",
                        "sonic_sensors_on_off",
                        "vision_systems_on_off",
                        "positional_program_entry",
                        "positional_program_play",
                        "gait_change_quit_reset",
                        "free_roam",
                        "dance_demo",
                        "_head_and_upper_body",
                        "reset",
                        "right_arm_throw",
                        "right_arm_low_pickup",
                        "right_arm_high_pickup",
                        "right_arm_grab",
                        "right_arm_give",
                        "right_arm_roll",
                        "movement_demo",
                        "_right_arm",
                        "sleep_wake_up",
                        "left_arm_throw",
                        "left_arm_low_pickup",
                        "left_arm_high_pickup",
                        "left_arm_grab",
                        "left_arm_give",
                        "left_arm_roll",
                        "lie_down_sit_up_lie_down_stand_up",
                        "_left_arm",
                        "get_up",
                        "right_kick",
                        "right_push",
                        "right_chop",
                        "left_chop",
                        "left_push",
                        "left_kick",
                        "oops",
                        "_hip_and_waist_tilt",
                        "clear_program",
                        "sound_program",
                        "vision_program",
                        "main_program",
                        "perform_program",
                        "guard_mode",
                        "clear_entry",
                        "high_5",
                        "_both_arms",
                        "bulldozer_forward",
                        "laugh",
                        "insult",
                        "right_arm_drop",
                        "left_arm_drop",
                        "plan",
                        "spare_change",
                        "hey_baby",
                        "_head_only",
                        "bulldozer_backward",
                        "roar",
                        "diode",
                        "fetch",
                        "danger",
                        "calm_down",
                        "hug",
                        "burp",
                        "_head_and_upper_body",
                        "power_down",
                        "robosapien_v2_interaction",
                        "roboraptor_interaction",
                        "robopet_interaction",
                        "manual_color_mode_daylight",
                        "manual_color_mode_indoor_yellow",
                        "manual_color_mode_indoor_white",
                        "dont_press",
                        "_upper_body_only" };

int codes2[NCMDSAPIEN2] = { 0x300, 0x3aa, 0x383, 0x380, 0x381, 0x352, 0x390, 0x382, 0x350,
                          0x320, 0x353, 0x355, 0x356, 0x357, 0x358, 0x359, 0x35a,
                          0x354, 0x328, 0x386, 0x35c, 0x35d, 0x35e, 0x35f, 0x360,
                          0x361, 0x351, 0x330, 0x364, 0x362, 0x365, 0x366, 0x367,
                          0x368, 0x363, 0x35b, 0x340, 0x3f4, 0x3f1, 0x3f0, 0x3f5,
                          0x3f6, 0x3f2, 0x3f3, 0x369, 0x338, 0x36a, 0x36c, 0x36d,
                          0x36e, 0x36f, 0x370, 0x371, 0x36b, 0x348, 0x372, 0x374,
                          0x375, 0x376, 0x377, 0x378, 0x379, 0x373, 0x310, 0x384,
                          0x385, 0x387, 0x388, 0x389, 0x38a, 0x38b, 0x37a, 0x318 };

char *petcmd[NCMDPET] = { "wake_up", "sleep", "stop", "guard", "demo", "good_dog",
                          "bad_dog", "turn_left", "turn_right", "forward", "backward",
                          "roll_over", "jump", "scratch", "howl", "paw", "play_dead",
                          "relief", "break_wind", "rock" };

int petcodes[NCMDPET] = { 0x2c1, 0x2c1, 0x28e, 0x2c3, 0x2c8, 0x2c4, 0x2c5, 0x280,
                            0x288, 0x286, 0x287, 0x2e1, 0x2e6, 0x2e9, 0x2e3, 0x2e4,
                            0x2e2, 0x2e5, 0x2e7, 0x2e8 };


void append_bits(unsigned char *code, int *i, unsigned char *bitsfilled, int n, unsigned char bit)
{
  bit <<= 7;
  /* first fill the current byte */
  while (*bitsfilled < 10)
  {
    if ((*bitsfilled > 0) && (*bitsfilled < 9))
    {
      code[*i] >>= 1;
      code[*i] |= bit;
    }
    (*bitsfilled)++; n--;
  }

  /* now fill all "full" bytes */
  while (n >= 10)
  {
    code[++(*i)] = bit?255:0;
    n -= 10;
  }

  /* and the last few bits that start another byte */
  (*i)++; *bitsfilled = 0;
  while (n > 0)
  {
    if ((*bitsfilled > 0) && (*bitsfilled < 9))
    {
      code[*i] >>= 1;
      code[*i] |= bit;
    }
    (*bitsfilled)++; n--;
  }
}

void sap_send(HANDLE f, int nowakeup, int b)
{
  int x = (b < 0x100)?128:2048;
  unsigned char code[1024];
  int i;
  unsigned char bitsfilled = 0;  /* 0-10  (counting also start and stop bits) */

  if (!nowakeup)
  {
      char *buf = "\0x00";
#ifdef WIN32
      DWORD written;
      WriteFile(f, buf, 1, &written, 0);
      FlushFileBuffers(f);
      Sleep(100);
#else
      write(f, buf, 1);
      struct timespec tm;
      tm.tv_sec = 0;
      tm.tv_nsec = 100000000;
      nanosleep(&tm, 0);
#endif
  }

  code[0] = 0;
  i = 0;

  append_bits(code, &i, &bitsfilled, 96 * 8, 0);

  while (x)
  {
    if (b & x) append_bits(code, &i, &bitsfilled, 96 * 4, 1);
    else append_bits(code, &i, &bitsfilled, 96, 1);
    append_bits(code, &i, &bitsfilled, 96, 0);
    x >>= 1;
  }

  if (bitsfilled > 0) i++;
  unsigned long written;
  int w = 0;
  while (w < i)
  {
#ifdef WIN32
    if (0 == WriteFile(f, code + w, i, &written, 0))
    {
      printf("sapien: problems writing to file, %d\n", GetLastError());
      return;
    }
#else
    written = write(f, code + w, i);
    if (written == -1)
    {
      printf("sapien: problems writing to file, %d\n", errno);
      return;
    }
#endif
    w += (int)written;
  }
}

int sap_decode(const char *sapien_cmd, int version)
{
  int i;
  if (version == 1) // RoboSapien
  {
    for (i = 0; i < NCMDSAPIEN; i++)
      if (strcmp(cmd[i], sapien_cmd) == 0)
          return 128 + i;
  }
  else if (version == 2) // RoboSapien V2
  {
    int dir = 0;
    const char *s;
    if (sapien_cmd[0] == 'D')
    {
        s = sapien_cmd + 2;
        dir = sapien_cmd[1] - '0';
    }
    else s = sapien_cmd;
    for (i = 0; i < NCMDSAPIEN2; i++)
      if (strcmp(cmd2[i], s) == 0)
       return codes2[i] + dir;
  }
  else if (version == 3) // RoboPet
  {
    for (i = 0; i < NCMDPET; i++)
      if (strcmp(petcmd[i], sapien_cmd) == 0)
        return petcodes[i];
  }
  printf("sapien: unrecognized command: %s\n", sapien_cmd);
  return 0;
}

#ifndef WIN32
struct termios oldtio;
#endif

HANDLE sap_open(const char *outport)
{
  HANDLE f;
#ifdef WIN32
  f = CreateFile(outport, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
  if (f == INVALID_HANDLE_VALUE)
  {
	printf("sapien: error opening port\n");
    return f;
  }
  if (strcmp(outport, "\\\\.\\legotower1") != 0)
  {
    if (!SetupComm(f, 64, 1024))
    {
      printf("sapien: Cannot setup port buffers\n");
      CloseHandle(f);
      return INVALID_HANDLE_VALUE;
    }
  }

  DCB dcb;
  FillMemory(&dcb, sizeof(dcb), 0);

  if (!GetCommState(f, &dcb))
  {
    printf("sapien: GetCommState() error: %d\n", GetLastError());
    CloseHandle(f);
    return INVALID_HANDLE_VALUE;
  }

  dcb.BaudRate = CBR_115200;
  dcb.fParity = FALSE;
  dcb.fOutxCtsFlow = FALSE;
  dcb.fOutxDsrFlow = FALSE;
  dcb.fDtrControl = DTR_CONTROL_DISABLE;
  dcb.fDsrSensitivity = FALSE;
  dcb.fTXContinueOnXoff = TRUE;
  dcb.fOutX = FALSE;
  dcb.fInX = FALSE;
  dcb.fRtsControl = RTS_CONTROL_DISABLE;
  dcb.fAbortOnError = FALSE;
  dcb.ByteSize = 8;
  dcb.Parity = NOPARITY;
  dcb.StopBits = ONESTOPBIT;

  if (!SetCommState(f, &dcb))
  {
    printf("sapien: SetCommState() error %d\n", GetLastError());
    CloseHandle(f);
    return INVALID_HANDLE_VALUE;
  }

#else
  f = open(outport, O_RDWR | O_NOCTTY | O_NONBLOCK);
  if (f < 0)
  {
    perror(outport);
    return INVALID_HANDLE_VALUE;
  }

  struct termios newtio;
  int fd = open(outport, O_RDWR | O_NOCTTY | O_NONBLOCK);
  if (fd < 0) { perror(outport); return INVALID_HANDLE_VALUE; }

  tcgetattr(fd,&oldtio); /* save current port settings */

  bzero(&newtio, sizeof(newtio));
  newtio.c_cflag = B115200 | CS8 | CLOCAL ;
  newtio.c_iflag = IGNPAR;
  newtio.c_oflag = 0;
  newtio.c_lflag = 0;
  newtio.c_cc[VTIME] = 0;
  newtio.c_cc[VMIN] = 1;
  cfsetspeed(&newtio, B115200);
  tcflush(fd, TCIFLUSH);
  if (tcsetattr(fd,TCSANOW,&newtio))
  {
    perror("tcsetattr()");
    close(fd);
    return INVALID_HANDLE_VALUE;
  }
#endif

  return f;
}

void sap_close(HANDLE f)
{
#ifdef WIN32
  CloseHandle(f);
#else
  tcsetattr(f,TCSANOW,&oldtio);
  close(f);
#endif
}
